"Smalltalk code from Chapter 10 of the Smalltalk/V Tutorial"!


! AnimalHabitat methods !

reply
        "Initialize reply pane with an
         empty String."
    ^String new!
graph: aRect
        "Initialize graph pane area to aRect and the
         animation associated with it."
    | aForm |
    aForm := Form
        width: aRect width
        height: aRect height.
    aForm displayAt: aRect origin.  "background"
    animator := Animation new initialize: aRect.
    animals do: [:anAnimal |
        animator
            add: anAnimal picture
            name: anAnimal name
            color: anAnimal color].
    ^aForm!
playSelection
        "Accept selected string as the script
         and play it to animals."
    self changed: #reply.
    CursorManager execute change.
    self script: inputPane selectedString.
    self play.
    CursorManager normal change!
playAll
        "Accept the entire content of the pane
         as the script and play it to animals."
    self changed: #reply.
    CursorManager execute change.
    self script: inputPane contents.
    self play.
    CursorManager normal change!
answer: aString
        "Output aString to the reply Pane."
    replyStream
        nextPutAll: aString;
        cr!
release
        "Window is closed, release all the
         objects created by this habitat."
    inputPane := replyStream := nil.
    super release! !

