
Object subclass: #Diskette
  instanceVariableNames: 
    'defaultDiskDrive type identity '
  classVariableNames: 
    'LogicalDrives '
  poolDictionaries: '' !

! Diskette class methods !

drive: aCharacter
    ^self new
        drive: aCharacter;
        getIdentity!

freeDiskSpace
    "Answer the free space in bytes on the disk
     containing the current directory."
    ^self dosError: (Dos freeDiskSpace)!

logicalDrives
    ^LogicalDrives! !


! Diskette methods !

drive: aCharacter
    (Diskette logicalDrives includes: aCharacter)
        ifTrue: [defaultDiskDrive = aCharacter]
        ifFalse: [self error:
            'Invalid drive: $' ,
             (String with: aCharacter)]!

getIdentity!

removableMedia
    ^(type bitAnd: 1) = 1! !
