
Switch subclass: #Button
  instanceVariableNames: ''
  classVariableNames: ''
  poolDictionaries: '' !

!Button class methods ! !


!Button methods !

draw: anInteger
        "Draw the button anInteger."
    form border: ((areas at: anInteger) translateBy: frame origin)
        rule: Form over
        mask: foreColor!

reverse: anInteger
        "Reverse the color of the button
         indexed by anInteger."
    | area |
    (anInteger < 1 or: [anInteger > areas size])
        ifTrue: [^self].
    area := areas at: anInteger.
    BitBlt new
        destForm: form
        sourceForm: nil
        halftone: nil
        combinationRule: Form reverse
        destOrigin: area origin
            + frame origin + (2 @ 2)
        sourceOrigin: 0 @ 0
        extent: area extent - (4 @ 4)
        clipRect: frame;
        copyBits!

switch: anInteger contain: aPoint
        "Answer true if aRectangle
         contains aPoint."
    ^true! !
