"Smalltalk code from Chapter 9 of the Smalltalk/V Tutorial"!


!NetworkNode methods !

<= aNode
        "Answer true if receiver name less or equal to
         aNode name."
    ^name <= aNode name!

draw
        "Draw the receiver node with a
         circle around its name."
    | font r aspect pen |
    font := Font eightLine.
    (pen := Pen new)
        defaultNib: 2;
        mask: Form white.
    pen place: position.
    pen solidEllipse: (r := name size * font width + 15 // 2)
        aspect: (aspect := font height + 16 / r / 2 / Aspect).
    pen mask: Form black.
    pen centerText: name font: font.
    pen ellipse: r aspect: aspect!

name
        "Answer receiver's name."
    ^name!

name: aString position: aPoint
        "Set the receivers name and position."
    name := aString.
    position := aPoint!

position
        "Answer the position of
         the receiver node."
    ^position!

printOn: aStream
        "Print a description of the receiver on aStream."
    aStream
        nextPutAll: 'Node(', name;
        space;
        nextPutAll: position printString;
        nextPut: $)! !
