Transcript cr; show: 'Filing in Scale'!

ControlApparatus subclass: #Scale
  instanceVariableNames: 
    'reading lowReading highReading '
  classVariableNames: ''
  poolDictionaries: '' !

!Scale class methods ! !


!Scale methods !

changeReading: anInteger
        "Answer the difference between anInteger
         and old reading. Draw needle to reflect
         the new reading anInteger."
    | newReading |
    newReading := (anInteger max: lowReading) min: highReading.
    lastChange := newReading rounded - reading rounded.
    reading := newReading.
    lastChange = 0
        ifFalse: [
            self eraseNeedle.
            self drawNeedle].
    ^lastChange!

increment: inc
        "Increment (or Decrement if inc is negative)
         the dial"
    self changeReading: ((reading + inc max: lowReading)
        min: highReading)!

reading
        "Answer the current reading."
    ^reading! !
