"Smalltalk code from Chapter 10 of the Smalltalk/V Tutorial"!


! AnimalHabitat methods !

openOn: aString
        "Create a kennel window with aString
         as its initial script." 
    | topPane replyPane |
    inputString := aString.
    topPane := TopPane new label: 'K E N N E L'.
    topPane addSubpane:
        (replyPane := TextPane new
            model: self;
            name: #reply;
            framingRatio: (0@0 extent: 2/3 @ (1/4))).
    topPane addSubpane:
        (GraphPane new
            model: self;
            name: #graph:;
            framingRatio: (0 @ (1/4) extent: 2/3 @ (3/4))).
    topPane addSubpane:
        (inputPane := TextPane new
            menu: #inputMenu;
            model: self;
            name: #input;
            framingRatio: (2/3 @ 0 extent: 1/3 @ 1)).
    topPane reframe:
        (Display boundingBox insetBy: 16@16).
    replyStream := replyPane dispatcher.
    topPane dispatcher openWindow scheduleWindow! !
